#include "SendRecvThread.h"
#include "MySyncObject.h"		// CMySyncObjectg

//----------------------------------------------
// function
//    RXgN^
// parameter
//    ConnectionInfoRec *pConInfo	[in]@\ɕKvȏ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::CSendRecvThread(ConnectionInfoRec *pConInfo)
{
	m_pConInfo = pConInfo;
	m_fIamZombie = FALSE;
	m_pSendData = NULL;			// Mf[^i[GA
	m_iSendDataSize = 0;		// Mf[^̃TCY
}


//----------------------------------------------
// function
//    fXgN^
// parameter
//    Ȃ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::~CSendRecvThread()
{
	SAFE_FREE(m_pSendData)		// Mf[^i[GAJ܂
	m_iSendDataSize = 0;
}

#define	RCVBUFSIZE		(1024)	// ɓǂލőMTCY
//----------------------------------------------
// function
//    @\Lq֐(DoSend, DoRecv̓eLq)
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
UINT CSendRecvThread::DoWork()
{
	BOOL		fRet = TRUE;
	pollfd		fds[1] = { 0 };
	char		*pcData = NULL;					// Mf[^
	int			iSendSize = 0;					// Mf[^TCY
	char	    szRecvBuffer[RCVBUFSIZE + 1];	// Mobt@
	int			iRecvSize;

	fds[0].fd = m_pConInfo->fdClient;

	while (!m_fStopFlag)
	{
		// M̃f[^ȂΑMf[^邩ׂ
		if (iSendSize == 0)
			iSendSize = GetSendData(&pcData);

		fds[0].events = POLLIN | POLLRDHUP;					// MƑ葤̐ؒfCxgݒ
		if (iSendSize > 0)
			fds[0].events = POLLOUT | POLLIN | POLLRDHUP;	// ݉\ǉ

		poll(fds, 1, 10);
		if (fds[0].revents & POLLERR)			// G[
		{
			DispErrorMsg("Err DoSend");
			fRet = FALSE;
			break;
		}
		if (fds[0].revents & POLLRDHUP)	// ؒf
		{
			DispErrorMsg("Disconnected");
			fRet = FALSE;
			break;
		}
		if (fds[0].revents & POLLIN)		// Mf[^Cxg
		{
			memset(szRecvBuffer, 0, sizeof(szRecvBuffer));
			if ((iRecvSize = recv(m_pConInfo->fdClient, szRecvBuffer, RCVBUFSIZE, 0)) <= 0)
			{
				m_pConInfo->pCMySyncObject->Lock();
				if (iRecvSize == 0)
					DispErrorMsg("Disconnected");
				else
					DispErrorMsg("Err:recv");
				m_pConInfo->pCMySyncObject->UnLock();
				fRet = FALSE;
				break;
			}
			else
			{
				// Mf[^̉
				if (AnalyzeDataRecv((BYTE *)szRecvBuffer, iRecvSize) == FALSE)
				{
					m_pConInfo->pCMySyncObject->Lock();
					DispErrorMsg("Err:Packet format");
					m_pConInfo->pCMySyncObject->UnLock();
					fRet = FALSE;
					break;
				}
			}
		}
		// M(DoSend)
		if (fds[0].revents & POLLOUT)					// M\Ȃsend{
		{
			if (send(m_pConInfo->fdClient, pcData, iSendSize, 0) != iSendSize)
			{
				DispErrorMsg("Err:send");
				fRet = FALSE;
				break;
			}
			SAFE_FREE(pcData)							// Mf[^ȂɃZbg
			iSendSize = 0;
		}
	}
	m_pConInfo->pCMySyncObject->Lock();
	m_fIamZombie = TRUE;
	m_pConInfo->pCMySyncObject->UnLock();
	SAFE_FREE(pcData)
	iSendSize = 0;
	return((fRet == TRUE) ? 0 : -1);
}

//----------------------------------------------
// function
//		Mf[^̐ݒ
// parameter
//		char	*pcData	[in]Mf[^
//		int		iSize	[in]f[^
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SetSendData(char *pcData, int iSize)
{
	BOOL	fRet = FALSE;

	m_pConInfo->pCMySyncObject->Lock();
	// Õf[^ǂ݂ĂȂƂ̓G[ɂ
	if (m_iSendDataSize == 0)
	{
		m_pSendData = (char *)calloc(iSize, sizeof(char));
		memcpy(m_pSendData, pcData, iSize);
		m_iSendDataSize = iSize;
		fRet = TRUE;
	}
	m_pConInfo->pCMySyncObject->UnLock();
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̎擾
// parameter
//		char **ppcData	[in/out]Mf[^
// return
//		f[^
//----------------------------------------------
int CSendRecvThread::GetSendData(char **ppcData)
{
	int		iSize = 0;

	m_pConInfo->pCMySyncObject->Lock();
	if (m_iSendDataSize > 0)
	{
		*ppcData = (char *)calloc(m_iSendDataSize, sizeof(char));
		memcpy(*ppcData, m_pSendData, m_iSendDataSize);
		iSize = m_iSendDataSize;
		SAFE_FREE(m_pSendData)		// ǂݏosƂZbg
		m_iSendDataSize = 0;
	}
	m_pConInfo->pCMySyncObject->UnLock();
	return(iSize);
}

//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
BOOL CSendRecvThread::IsZombie()
{
	BOOL	fRet;

	m_pConInfo->pCMySyncObject->Lock();
	fRet = m_fIamZombie;
	m_pConInfo->pCMySyncObject->UnLock();
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̉
// parameter
//		BYTE		*pbData		[in]Mf[^
//		int			iSize			[in]Mf[^TCY
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::AnalyzeDataRecv(BYTE *pbData, int iSize)
{
	BOOL				fRet = FALSE;
	HeaderRec	*pHeader;
	WORD			wCmd;

	if (iSize < sizeof(HeaderRec))			// wb_TCYɖȂƂ̓G[
		goto L_END;

	pHeader = (HeaderRec *)pbData;			// wb_̉
	if (memcmp(pHeader->bMagicData, MAGIC_STRING, strlen(MAGIC_STRING)) != 0)
		goto L_END;

	wCmd = ntohs(pHeader->wCommand);
	fprintf(stderr, "CMD:%d\n", wCmd);

	switch (wCmd)
	{
		case CMD_MSG_DATA:
			fRet = RecvMessagePacket(pbData, iSize);
			break;
		default:						// mȂR}h
			break;
	}
L_END:
	return(fRet);
}

//----------------------------------------------
// function
//		bZ[WR}h̎M
// parameter
//		char	*pcData		[in]bZ[WR}hpPbg
//		int	iSize			[in]f[^TCY
// retun
//		Ȃ
//----------------------------------------------
BOOL CSendRecvThread::RecvMessagePacket(BYTE *pbData, int iSize)
{
	BOOL		fRet = FALSE;
	HeaderRec	*pHeader;
	MsgDataRec	*pMsgData;
	int			iMsgSize;
	char		*pszMsg = NULL;

	pHeader = (HeaderRec *)pbData;
	iMsgSize = ntohs(pHeader->wDataLen);
	// f[^ȂƂ̓G[
	if (iSize < iMsgSize + sizeof(HeaderRec))
		goto L_END;

	pMsgData = (MsgDataRec *)pbData;
	// NULL^[~l[gǉĊm
	pszMsg = (char *)calloc(iMsgSize + 1, sizeof(char));
	memcpy(pszMsg, pMsgData->bMsgData, iMsgSize);

	m_pConInfo->pCMySyncObject->Lock();
	fprintf(stderr, "Msg:recv %s\n", pszMsg);
	m_pConInfo->pCMySyncObject->UnLock();
	SAFE_FREE(pszMsg)
	fRet = TRUE;
L_END:
	return(fRet);
}